# backend-template (Node.js)

## List of contents
- [Technologies used](#technologies-and-software-used)
- [List of libraries used](#list-of-libraries-used)
- [How to use](#how-to-use)

## Technologies used
| Technology name | Link |
|-----------------|------|
| Node.js |[Website](https://nodejs.org/)|
| PostgreSQL |[Website](https://www.postgresql.org/)|

## List of libraries used
| Library name | Purpose | Link |
|--------------|---------|------|
| bluebird |for parallel asynchronous operations ```await Promise.all([])```|[Website](https://www.npmjs.com/package/bluebird)|
| camelcase |for parsing filenames|[Website](https://www.npmjs.com/package/camelcase)|
| decamelize |for parsing filenames|[Website](https://www.npmjs.com/package/decamelize)|
| dotenv |for environment variables|[Website](https://www.npmjs.com/package/dotenv)|
| express |framework of the entire application for the API|[Website](https://www.npmjs.com/package/express)|
| cors |for corses|[Website](https://www.npmjs.com/package/cors)|
| morgan |for logging requests|[Website](https://www.npmjs.com/package/morgan)|
| log4js |for logging requests|[Website](https://www.npmjs.com/package/log4js)|
| chalk |for logging requests|[Website](https://www.npmjs.com/package/chalk)|
| pg |to work with the database |[Website](https://www.npmjs.com/package/pg)|
| pg-hstore |to work with the database |[Website](https://www.npmjs.com/package/pg-hstore)|
| sequelize |as an ORM for working with the database|[Website](https://www.npmjs.com/package/sequelize)|
| sequelize-auto-migrations |for automatic creation of migrations from ORM models|[Website](https://www.npmjs.com/package/sequelize-auto-migrations)|
| sequelize-cli |for database operations|[Website](https://www.npmjs.com/package/sequelize-cli)|
| ws |to work with the web socket|[Website](https://www.npmjs.com/package/ws)|
| joi |for validation|[Website](https://www.npmjs.com/package/joi)|


# How to use

## List of contents
- [Pre commit hook](#pre-commit-hook)
- [Run application](#run-application)

## Pre commit hook
Copy the .scripts/pre-commit file to the `.git/hooks/` folder to automatically fill in the build.json file before the commit.

## Run application
1. Copy .env.example, change its name to .env, and populate the file according to your environment;
2. Run the command:
```bash
npm i
```
to set dependencies;
3. Run the command:
```bash
npm run db:migrate:create
```
4. Run the command:
```bash
npm run db:seed
```
5. Execute the command:
```bash
npm run start
```
to run the application.
