require('dotenv').config();
require('./server/utils/check-dotenv');
const logger = require('./server/utils/override-console-log');

const express = require('express');
const cors = require('cors');
const morgan = require('morgan');
const chalk = require('chalk');
const {routify} = require('./server/api');

const app = express();

app.use(cors());
app.use(morgan(chalk`:method :url :status :res[content-length] - :response-time ms`, {
  stream: {
    write: function (message) {
      logger.info(message.trim());
    }
  }
}));
app.use(express.json({limit: '1024mb'}));

routify(app);

module.exports = app;
