const decodeJwt = require('../../middlewares/verify-admin-jwt');
const unpackAccessToken = require('../../middlewares/unpack-access-token');
const registerControllers = require('../../utils/register-controllers');
const catchWrap = require('../../utils/exception-catch-wrapper');

/**
* @module Module for configuring routes and registering public scopes controllers.
* @param {Object} router - The Express router object.
* @param {string} prefix - Prefix for route paths.
*/
module.exports = (router, prefix) => {
  router.use(prefix, catchWrap(unpackAccessToken));
  router.use(prefix, catchWrap(decodeJwt));

  registerControllers(__dirname, prefix, router);
};
