const Sequelize = require('sequelize');
const fs = require('fs');
const path = require('path');
const dbConfig = require('../../configs/db.js');

const sequelize = new Sequelize(dbConfig[process.env.NODE_ENV]);

const db = {};
db.Sequelize = Sequelize;
db.sequelize = sequelize;

const basename = path.basename(__filename);

fs.readdirSync(__dirname).filter(file => {
  return (file.indexOf('.') !== 0) && (file !== basename) && (file.slice(-3) === '.js');
}).forEach(file => {
  const model = require(path.join(__dirname, file))(sequelize, Sequelize.DataTypes);
  db[model.name] = model;
});

Object.keys(db).forEach(modelName => {
  if (db[modelName].associate) {
    db[modelName].associate(db);
  }
});

module.exports = db;
